var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import cn from "clsx";
import { Anchor } from "./anchor";
var classes = {
    cards: cn("nextra-cards nx-mt-4 nx-gap-4 nx-grid"),
    card: cn("nextra-card nx-group nx-flex nx-flex-col nx-justify-start nx-overflow-hidden nx-rounded-lg nx-border nx-border-gray-200", "nx-text-current nx-no-underline dark:nx-shadow-none", "hover:nx-shadow-gray-100 dark:hover:nx-shadow-none nx-shadow-gray-100", "active:nx-shadow-sm active:nx-shadow-gray-200", "nx-transition-all nx-duration-200 hover:nx-border-gray-300"),
    title: cn("nx-flex nx-font-semibold nx-items-start nx-gap-2 nx-p-4 nx-text-gray-700 hover:nx-text-gray-900")
};
var arrowEl = (_jsx("span", { className: "nx-transition-transform nx-duration-75 group-hover:nx-translate-x-[2px]", children: "\u2192" }));
export function Card(_a) {
    var children = _a.children, title = _a.title, icon = _a.icon, image = _a.image, arrow = _a.arrow, href = _a.href, props = __rest(_a, ["children", "title", "icon", "image", "arrow", "href"]);
    var animatedArrow = arrow ? arrowEl : null;
    if (image) {
        return (_jsxs(Anchor, __assign({ href: href, className: cn(classes.card, "nx-bg-gray-100 nx-shadow dark:nx-border-neutral-700 dark:nx-bg-neutral-800 dark:nx-text-gray-50 hover:nx-shadow-lg dark:hover:nx-border-neutral-500 dark:hover:nx-bg-neutral-700") }, props, { children: [children, _jsxs("span", { className: cn(classes.title, "dark:nx-text-gray-300 dark:hover:nx-text-gray-100"), children: [icon, _jsxs("span", { className: "nx-flex nx-gap-1", children: [title, animatedArrow] })] })] })));
    }
    return (_jsx(Anchor, __assign({ href: href, className: cn(classes.card, "nx-bg-transparent nx-shadow-sm dark:nx-border-neutral-800 hover:nx-bg-slate-50 hover:nx-shadow-md dark:hover:nx-border-neutral-700 dark:hover:nx-bg-neutral-900") }, props, { children: _jsxs("span", { className: cn(classes.title, "dark:nx-text-neutral-200 dark:hover:nx-text-neutral-50"), children: [icon, title, animatedArrow] }) })));
}
export function Cards(_a) {
    var children = _a.children, _b = _a.num, num = _b === void 0 ? 3 : _b, className = _a.className, style = _a.style, props = __rest(_a, ["children", "num", "className", "style"]);
    return (_jsx("div", __assign({ className: cn(classes.cards, className) }, props, { style: __assign(__assign({}, style), { "--rows": num }), children: children })));
}
//# sourceMappingURL=cards.js.map