import { jsx as _jsx } from "react/jsx-runtime";
import cn from "clsx";
import { useEffect, useRef } from "react";
export function Collapse(_a) {
    var children = _a.children, className = _a.className, isOpen = _a.isOpen, _b = _a.horizontal, horizontal = _b === void 0 ? false : _b;
    var containerRef = useRef(null);
    var innerRef = useRef(null);
    var animationRef = useRef(0);
    var initialOpen = useRef(isOpen);
    var initialRender = useRef(true);
    useEffect(function () {
        var container = containerRef.current;
        var inner = innerRef.current;
        var animation = animationRef.current;
        if (animation) {
            clearTimeout(animation);
        }
        if (initialRender.current || !container || !inner)
            return;
        container.classList.toggle("nx-duration-500", !isOpen);
        container.classList.toggle("nx-duration-300", isOpen);
        if (horizontal) {
            // save initial width to avoid word wrapping when container width will be changed
            inner.style.width = "".concat(inner.clientWidth, "px");
            container.style.width = "".concat(inner.clientWidth, "px");
        }
        else {
            container.style.height = "".concat(inner.clientHeight, "px");
        }
        if (isOpen) {
            animationRef.current = window.setTimeout(function () {
                // should be style property in kebab-case, not css class name
                container.style.removeProperty("height");
            }, 300);
        }
        else {
            setTimeout(function () {
                if (horizontal) {
                    container.style.width = "0px";
                }
                else {
                    container.style.height = "0px";
                }
            }, 0);
        }
    }, [horizontal, isOpen]);
    useEffect(function () {
        initialRender.current = false;
    }, []);
    return (_jsx("div", { ref: containerRef, className: "nx-transform-gpu nx-overflow-hidden nx-transition-all nx-ease-in-out motion-reduce:nx-transition-none", style: initialOpen.current || horizontal ? undefined : { height: 0 }, children: _jsx("div", { ref: innerRef, className: cn("nx-transition-opacity nx-duration-500 nx-ease-in-out motion-reduce:nx-transition-none", isOpen ? "nx-opacity-100" : "nx-opacity-0", className), children: children }) }));
}
//# sourceMappingURL=collapse.js.map