var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import cn from "clsx";
import { createContext, memo, useCallback, useContext, useState } from "react";
var ctx = createContext(0);
function useIndent() {
    return useContext(ctx);
}
var Tree = function (_a) {
    var children = _a.children;
    return (_jsx("div", { className: "nx-mt-6 nx-select-none nx-text-sm nx-text-gray-800 dark:nx-text-gray-300", children: _jsx("div", { className: "nx-inline-flex nx-flex-col nx-rounded-lg nx-border nx-px-4 nx-py-2 dark:nx-border-neutral-800", children: children }) }));
};
function Ident() {
    var indent = useIndent();
    return (_jsx(_Fragment, { children: __spreadArray([], __read(Array(indent)), false).map(function (_, i) { return (_jsx("span", { className: "nx-inline-block nx-w-5" }, i)); }) }));
}
var Folder = memo(function (_a) {
    var label = _a.label, name = _a.name, open = _a.open, children = _a.children, _b = _a.defaultOpen, defaultOpen = _b === void 0 ? false : _b, onToggle = _a.onToggle;
    var indent = useIndent();
    var _c = __read(useState(defaultOpen), 2), isOpen = _c[0], setIsOpen = _c[1];
    var toggle = useCallback(function () {
        onToggle === null || onToggle === void 0 ? void 0 : onToggle(!isOpen);
        setIsOpen(!isOpen);
    }, [isOpen, onToggle]);
    var isFolderOpen = open === undefined ? isOpen : open;
    return (_jsxs("li", { className: "nx-flex nx-list-none nx-flex-col", children: [_jsxs("a", { onClick: toggle, title: name, className: "nx-inline-flex nx-cursor-pointer nx-items-center nx-py-1 hover:nx-opacity-60", children: [_jsx(Ident, {}), _jsx("svg", { width: "1em", height: "1em", viewBox: "0 0 24 24", children: _jsx("path", { fill: "none", stroke: "currentColor", strokeLinecap: "round", strokeLinejoin: "round", strokeWidth: "2", d: isFolderOpen
                                ? "M5 19a2 2 0 0 1-2-2V7a2 2 0 0 1 2-2h4l2 2h4a2 2 0 0 1 2 2v1M5 19h14a2 2 0 0 0 2-2v-5a2 2 0 0 0-2-2H9a2 2 0 0 0-2 2v5a2 2 0 0 1-2 2Z"
                                : "M3 7v10a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2V9a2 2 0 0 0-2-2h-6l-2-2H5a2 2 0 0 0-2 2Z" }) }), _jsx("span", { className: "nx-ml-1", children: label !== null && label !== void 0 ? label : name })] }), isFolderOpen && (_jsx("ul", { children: _jsx(ctx.Provider, { value: indent + 1, children: children }) }))] }));
});
Folder.displayName = "Folder";
var File = memo(function (_a) {
    var label = _a.label, name = _a.name, active = _a.active;
    return (_jsx("li", { className: cn("nx-flex nx-list-none", active && "nx-text-primary-600 contrast-more:nx-underline"), children: _jsxs("a", { className: "nx-inline-flex nx-cursor-default nx-items-center nx-py-1", children: [_jsx(Ident, {}), _jsx("svg", { width: "1em", height: "1em", viewBox: "0 0 24 24", children: _jsx("path", { fill: "none", stroke: "currentColor", strokeLinecap: "round", strokeLinejoin: "round", strokeWidth: "2", d: "M9 12h6m-6 4h6m2 5H7a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h5.586a1 1 0 0 1 .707.293l5.414 5.414a1 1 0 0 1 .293.707V19a2 2 0 0 1-2 2Z" }) }), _jsx("span", { className: "nx-ml-1", children: label !== null && label !== void 0 ? label : name })] }) }));
});
File.displayName = "File";
export var FileTree = Object.assign(Tree, { Folder: Folder, File: File });
//# sourceMappingURL=file-tree.js.map