var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import cn from "clsx";
import FlexSearch from "flexsearch";
import { useRouter } from "next/router";
import { useCallback, useState } from "react";
import { DEFAULT_LOCALE } from "../constants";
import { HighlightMatches } from "./highlight-matches";
import { Search } from "./search";
// This can be global for better caching.
var indexes = {};
// Caches promises that load the index
var loadIndexesPromises = new Map();
var loadIndexes = function (basePath, locale) {
    var key = basePath + "@" + locale;
    if (loadIndexesPromises.has(key)) {
        return loadIndexesPromises.get(key);
    }
    var promise = loadIndexesImpl(basePath, locale);
    loadIndexesPromises.set(key, promise);
    return promise;
};
var loadIndexesImpl = function (basePath, locale) { return __awaiter(void 0, void 0, void 0, function () {
    var response, data, pageIndex, sectionIndex, pageId, route, pageContent, heading, _a, hash, text, url, title, content, paragraphs, i;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, fetch("".concat(basePath, "/_next/static/chunks/nextra-data-").concat(locale, ".json"))];
            case 1:
                response = _b.sent();
                return [4 /*yield*/, response.json()];
            case 2:
                data = (_b.sent());
                pageIndex = new FlexSearch.Document({
                    cache: 100,
                    tokenize: "full",
                    document: {
                        id: "id",
                        index: "content",
                        store: ["title"]
                    },
                    context: {
                        resolution: 9,
                        depth: 2,
                        bidirectional: true
                    }
                });
                sectionIndex = new FlexSearch.Document({
                    cache: 100,
                    tokenize: "full",
                    document: {
                        id: "id",
                        index: "content",
                        tag: "pageId",
                        store: ["title", "content", "url", "display"]
                    },
                    context: {
                        resolution: 9,
                        depth: 2,
                        bidirectional: true
                    }
                });
                pageId = 0;
                for (route in data) {
                    pageContent = "";
                    ++pageId;
                    for (heading in data[route].data) {
                        _a = __read(heading.split("#"), 2), hash = _a[0], text = _a[1];
                        url = route + (hash ? "#" + hash : "");
                        title = text || data[route].title;
                        content = data[route].data[heading] || "";
                        paragraphs = content.split("\n").filter(Boolean);
                        sectionIndex.add(__assign({ id: url, url: url, title: title, pageId: "page_".concat(pageId), content: title }, (paragraphs[0] && { display: paragraphs[0] })));
                        for (i = 0; i < paragraphs.length; i++) {
                            sectionIndex.add({
                                id: "".concat(url, "_").concat(i),
                                url: url,
                                title: title,
                                pageId: "page_".concat(pageId),
                                content: paragraphs[i]
                            });
                        }
                        // Add the page itself.
                        pageContent += " ".concat(title, " ").concat(content);
                    }
                    pageIndex.add({
                        id: pageId,
                        title: data[route].title,
                        content: pageContent
                    });
                }
                indexes[locale] = [pageIndex, sectionIndex];
                return [2 /*return*/];
        }
    });
}); };
export function Flexsearch(_a) {
    var _this = this;
    var className = _a.className;
    var _b = useRouter(), _c = _b.locale, locale = _c === void 0 ? DEFAULT_LOCALE : _c, basePath = _b.basePath;
    var _d = __read(useState(false), 2), loading = _d[0], setLoading = _d[1];
    var _e = __read(useState(false), 2), error = _e[0], setError = _e[1];
    var _f = __read(useState([]), 2), results = _f[0], setResults = _f[1];
    var _g = __read(useState(""), 2), search = _g[0], setSearch = _g[1];
    var doSearch = function (search) {
        var _a, _b;
        if (!search)
            return;
        var _c = __read(indexes[locale], 2), pageIndex = _c[0], sectionIndex = _c[1];
        // Show the results for the top 5 pages
        var pageResults = ((_a = pageIndex.search(search, 5, {
            enrich: true,
            suggest: true
        })[0]) === null || _a === void 0 ? void 0 : _a.result) || [];
        var results = [];
        var pageTitleMatches = {};
        for (var i = 0; i < pageResults.length; i++) {
            var result = pageResults[i];
            pageTitleMatches[i] = 0;
            // Show the top 5 results for each page
            var sectionResults = ((_b = sectionIndex.search(search, 5, {
                enrich: true,
                suggest: true,
                tag: "page_".concat(result.id)
            })[0]) === null || _b === void 0 ? void 0 : _b.result) || [];
            var isFirstItemOfPage = true;
            var occurred = {};
            for (var j = 0; j < sectionResults.length; j++) {
                var doc = sectionResults[j].doc;
                var isMatchingTitle = doc.display !== undefined;
                if (isMatchingTitle) {
                    pageTitleMatches[i]++;
                }
                var url = doc.url, title = doc.title;
                var content = doc.display || doc.content;
                if (occurred[url + "@" + content])
                    continue;
                occurred[url + "@" + content] = true;
                results.push({
                    _page_rk: i,
                    _section_rk: j,
                    route: url,
                    prefix: isFirstItemOfPage && (_jsx("div", { className: cn("nx-mx-2.5 nx-mb-2 nx-mt-6 nx-select-none nx-border-b nx-border-black/10 nx-px-2.5 nx-pb-1.5 nx-text-xs nx-font-semibold nx-uppercase nx-text-gray-500 first:nx-mt-0 dark:nx-border-white/20 dark:nx-text-gray-300", "contrast-more:nx-border-gray-600 contrast-more:nx-text-gray-900 contrast-more:dark:nx-border-gray-50 contrast-more:dark:nx-text-gray-50"), children: result.doc.title })),
                    children: (_jsxs(_Fragment, { children: [_jsx("div", { className: "nx-text-base nx-font-semibold nx-leading-5", children: _jsx(HighlightMatches, { match: search, value: title }) }), content && (_jsx("div", { className: "excerpt nx-mt-1 nx-text-sm nx-leading-[1.35rem] nx-text-gray-600 dark:nx-text-gray-400 contrast-more:dark:nx-text-gray-50", children: _jsx(HighlightMatches, { match: search, value: content }) }))] }))
                });
                isFirstItemOfPage = false;
            }
        }
        setResults(results
            .sort(function (a, b) {
            // Sort by number of matches in the title.
            if (a._page_rk === b._page_rk) {
                return a._section_rk - b._section_rk;
            }
            if (pageTitleMatches[a._page_rk] !== pageTitleMatches[b._page_rk]) {
                return pageTitleMatches[b._page_rk] - pageTitleMatches[a._page_rk];
            }
            return a._page_rk - b._page_rk;
        })
            .map(function (res) { return ({
            id: "".concat(res._page_rk, "_").concat(res._section_rk),
            route: res.route,
            prefix: res.prefix,
            children: res.children
        }); }));
    };
    var preload = useCallback(function (active) { return __awaiter(_this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(active && !indexes[locale])) return [3 /*break*/, 5];
                    setLoading(true);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, loadIndexes(basePath, locale)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    setError(true);
                    return [3 /*break*/, 4];
                case 4:
                    setLoading(false);
                    _a.label = 5;
                case 5: return [2 /*return*/];
            }
        });
    }); }, [locale, basePath]);
    var handleChange = function (value) { return __awaiter(_this, void 0, void 0, function () {
        var e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setSearch(value);
                    if (loading) {
                        return [2 /*return*/];
                    }
                    if (!!indexes[locale]) return [3 /*break*/, 5];
                    setLoading(true);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, loadIndexes(basePath, locale)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_2 = _a.sent();
                    setError(true);
                    return [3 /*break*/, 4];
                case 4:
                    setLoading(false);
                    _a.label = 5;
                case 5:
                    doSearch(value);
                    return [2 /*return*/];
            }
        });
    }); };
    return (_jsx(Search, { loading: loading, error: error, value: search, onChange: handleChange, onActive: preload, className: className, overlayClassName: "nx-w-screen nx-min-h-[100px] nx-max-w-[min(calc(100vw-2rem),calc(100%+20rem))]", results: results }));
}
//# sourceMappingURL=flexsearch.js.map