var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { NextSeo } from "next-seo";
import { useTheme } from "next-themes";
import NextHead from "next/head";
import { useMounted } from "nextra/hooks";
import { useConfig } from "../contexts";
export function Head() {
    var _a;
    var config = useConfig();
    var resolvedTheme = useTheme().resolvedTheme;
    var mounted = useMounted();
    // `head` can be either FC or ReactNode. We have to directly call it if it's an
    // FC because hooks like Next.js' `useRouter` aren't allowed inside NextHead.
    var head = typeof config.head === "function" ? config.head({}) : config.head;
    var hue = config.primaryHue;
    var _b = typeof hue === "number" ? { dark: hue, light: hue } : hue, darkHue = _b.dark, lightHue = _b.light;
    var frontMatter = config.frontMatter;
    return (_jsxs(_Fragment, { children: [_jsx(NextSeo, __assign({ title: config.title, description: frontMatter.description, canonical: frontMatter.canonical, openGraph: frontMatter.openGraph }, (_a = config.useNextSeoProps) === null || _a === void 0 ? void 0 : _a.call(config))), _jsxs(NextHead, { children: [config.faviconGlyph ? (_jsx("link", { rel: "icon", href: "data:image/svg+xml;utf8,<svg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 100 100'><text x='50' y='.9em' font-size='90' text-anchor='middle'>".concat(config.faviconGlyph, "</text><style>text{font-family:system-ui,-apple-system,BlinkMacSystemFont,\"Segoe UI\",Roboto,\"Helvetica Neue\",Arial,\"Noto Sans\",sans-serif,\"Apple Color Emoji\",\"Segoe UI Emoji\",\"Segoe UI Symbol\",\"Noto Color Emoji\";fill:black}@media(prefers-color-scheme:dark){text{fill:white}}</style></svg>") })) : null, mounted ? (_jsx("meta", { name: "theme-color", content: resolvedTheme === "dark" ? "#111" : "#fff" })) : (_jsxs(_Fragment, { children: [_jsx("meta", { name: "theme-color", content: "#fff", media: "(prefers-color-scheme: light)" }), _jsx("meta", { name: "theme-color", content: "#111", media: "(prefers-color-scheme: dark)" })] })), _jsx("meta", { name: "viewport", content: "width=device-width, initial-scale=1.0, viewport-fit=cover" }), _jsx("style", { children: "\n        :root {\n          --nextra-primary-hue: ".concat(lightHue, "deg;\n          --nextra-navbar-height: 4rem;\n          --nextra-menu-height: 3.75rem;\n          --nextra-banner-height: 2.5rem;\n        }\n        \n        .dark {\n          --nextra-primary-hue: ").concat(darkHue, "deg;\n        }\n      ") }), head] })] }));
}
//# sourceMappingURL=head.js.map