var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { Menu, Transition } from "@headlessui/react";
import cn from "clsx";
import { useFSRoute } from "nextra/hooks";
import { ArrowRightIcon, MenuIcon } from "nextra/icons";
import { useConfig, useMenu } from "../contexts";
import { renderComponent } from "../utils";
import { Anchor } from "./anchor";
import { Header } from "@codegouvfr/react-dsfr/Header";
import { exclude } from "tsafe/exclude";
import { id } from "tsafe/id";
var classes = {
    link: cn("nx-text-sm contrast-more:nx-text-gray-700 contrast-more:dark:nx-text-gray-100"),
    active: cn("nx-font-medium nx-subpixel-antialiased"),
    inactive: cn("nx-text-gray-600 hover:nx-text-gray-800 dark:nx-text-gray-400 dark:hover:nx-text-gray-200")
};
function NavbarMenu(_a) {
    var className = _a.className, menu = _a.menu, children = _a.children;
    var items = menu.items;
    var routes = Object.fromEntries((menu.children || []).map(function (route) { return [route.name, route]; }));
    return (_jsx("div", { className: "nx-relative nx-inline-block", children: _jsxs(Menu, { children: [_jsx(Menu.Button, { className: cn(className, "-nx-ml-2 nx-hidden nx-items-center nx-whitespace-nowrap nx-rounded nx-p-2 md:nx-inline-flex", classes.inactive), children: children }), _jsx(Transition, { leave: "nx-transition-opacity", leaveFrom: "nx-opacity-100", leaveTo: "nx-opacity-0", children: _jsx(Menu.Items, { className: "nx-absolute nx-right-0 nx-z-20 nx-mt-1 nx-max-h-64 nx-min-w-full nx-overflow-auto nx-rounded-md nx-ring-1 nx-ring-black/5 nx-bg-white nx-py-1 nx-text-sm nx-shadow-lg dark:nx-ring-white/20 dark:nx-bg-neutral-800", tabIndex: 0, children: Object.entries(items || {}).map(function (_a) {
                            var _b;
                            var _c = __read(_a, 2), key = _c[0], item = _c[1];
                            return (_jsx(Menu.Item, { children: _jsx(Anchor, { href: item.href || ((_b = routes[key]) === null || _b === void 0 ? void 0 : _b.route) || menu.route + "/" + key, className: cn("nx-relative nx-hidden nx-w-full nx-select-none nx-whitespace-nowrap nx-text-gray-600 hover:nx-text-gray-900 dark:nx-text-gray-400 dark:hover:nx-text-gray-100 md:nx-inline-block", "nx-py-1.5 nx-transition-colors ltr:nx-pl-3 ltr:nx-pr-9 rtl:nx-pr-3 rtl:nx-pl-9"), newWindow: item.newWindow, children: item.title || key }) }, key));
                        }) }) })] }) }));
}
export function Navbar(_a) {
    var flatDirectories = _a.flatDirectories, items = _a.items;
    var config = useConfig();
    var activeRoute = useFSRoute();
    var _b = useMenu(), menu = _b.menu, setMenu = _b.setMenu;
    console.log({ items: items });
    return (_jsxs(_Fragment, { children: [_jsxs("div", { className: "nextra-nav-container nx-sticky nx-top-0 nx-z-20 nx-w-full nx-bg-transparent print:nx-hidden", children: [_jsx("div", { className: cn("nextra-nav-container-blur", "nx-pointer-events-none nx-absolute nx-z-[-1] nx-h-full nx-w-full nx-bg-white dark:nx-bg-dark", "nx-shadow-[0_2px_4px_rgba(0,0,0,.02),0_1px_0_rgba(0,0,0,.06)] dark:nx-shadow-[0_-1px_0_rgba(255,255,255,.1)_inset]", "contrast-more:nx-shadow-[0_0_0_1px_#000] contrast-more:dark:nx-shadow-[0_0_0_1px_#fff]") }), _jsxs("nav", { className: "nx-mx-auto nx-flex nx-h-[var(--nextra-navbar-height)] nx-max-w-[90rem] nx-items-center nx-justify-end nx-gap-2 nx-pl-[max(env(safe-area-inset-left),1.5rem)] nx-pr-[max(env(safe-area-inset-right),1.5rem)]", children: [items.map(function (pageOrMenu) {
                                if (pageOrMenu.display === "hidden")
                                    return null;
                                if (pageOrMenu.type === "menu") {
                                    var menu_1 = pageOrMenu;
                                    var isActive_1 = menu_1.route === activeRoute || activeRoute.startsWith(menu_1.route + "/");
                                    return (_jsxs(NavbarMenu, { className: cn(classes.link, "nx-flex nx-gap-1", isActive_1 ? classes.active : classes.inactive), menu: menu_1, children: [menu_1.title, _jsx(ArrowRightIcon, { className: "nx-h-[18px] nx-min-w-[18px] nx-rounded-sm nx-p-0.5", pathClassName: "nx-origin-center nx-transition-transform nx-rotate-90" })] }, menu_1.title));
                                }
                                var page = pageOrMenu;
                                var href = page.href || page.route || "#";
                                // If it's a directory
                                if (page.children) {
                                    href = (page.withIndexPage ? page.route : page.firstChildRoute) || href;
                                }
                                var isActive = page.route === activeRoute || activeRoute.startsWith(page.route + "/");
                                return (_jsxs(Anchor, { href: href, className: cn(classes.link, "nx-relative -nx-ml-2 nx-hidden nx-whitespace-nowrap nx-p-2 md:nx-inline-block", !isActive || page.newWindow ? classes.inactive : classes.active), newWindow: page.newWindow, "aria-current": !page.newWindow && isActive, children: [_jsx("span", { className: "nx-absolute nx-inset-x-0 nx-text-center", children: page.title }), _jsx("span", { className: "nx-invisible nx-font-medium", children: page.title })] }, href));
                            }), renderComponent(config.search.component, {
                                directories: flatDirectories,
                                className: "nx-hidden md:nx-inline-block mx-min-w-[200px]"
                            }), config.project.link ? (_jsx(Anchor, { className: "nx-p-2 nx-text-current", href: config.project.link, newWindow: true, children: renderComponent(config.project.icon) })) : null, config.chat.link ? (_jsx(Anchor, { className: "nx-p-2 nx-text-current", href: config.chat.link, newWindow: true, children: renderComponent(config.chat.icon) })) : null, renderComponent(config.navbar.extraContent), _jsx("button", { type: "button", "aria-label": "Menu", className: "nextra-hamburger -nx-mr-2 nx-rounded nx-p-2 active:nx-bg-gray-400/20 md:nx-hidden", onClick: function () { return setMenu(!menu); }, children: _jsx(MenuIcon, { className: cn({ open: menu }) }) })] })] }), _jsx(Header, { brandTop: _jsxs(_Fragment, { children: ["INTITULE", _jsx("br", {}), "OFFICIEL"] }), homeLinkProps: {
                    "href": "/",
                    "title": "Accueil - Nom de l’entité (ministère, secrétariat d‘état, gouvernement)"
                }, serviceTagline: "baseline - pr\u00E9cisions sur l'organisation", serviceTitle: "Nom du site / service", quickAccessItems: [
                    {
                        iconId: "fr-icon-add-circle-line",
                        linkProps: {
                            href: "#"
                        },
                        text: "Créer un espace"
                    },
                    {
                        iconId: "ri-account-circle-line",
                        linkProps: {
                            href: "#"
                        },
                        text: "S’enregistrer"
                    }
                ], renderSearchInput: function (params) { return _jsx("input", __assign({}, params)); }, navigation: items
                    .map(function (pageOrMenu) {
                    if (pageOrMenu.display === "hidden") {
                        return undefined;
                    }
                    if (pageOrMenu.type === "menu") {
                        var menu_2 = pageOrMenu;
                        var isActive_2 = menu_2.route === activeRoute || activeRoute.startsWith(menu_2.route + "/");
                        return id({
                            "isActive": isActive_2,
                            "text": menu_2.title,
                            "menuLinks": Object.values(menu_2.items).map(function (_a) {
                                var title = _a.title, href = _a.href, newWindow = _a.newWindow;
                                return ({
                                    "isActive": true,
                                    "linkProps": {
                                        "href": href !== null && href !== void 0 ? href : "#",
                                        "target": newWindow ? "_blank" : undefined
                                    },
                                    "text": title
                                });
                            })
                        });
                    }
                    var page = pageOrMenu;
                    var href = page.href || page.route || "#";
                    // If it's a directory
                    if (page.children) {
                        href = (page.withIndexPage ? page.route : page.firstChildRoute) || href;
                    }
                    var isActive = page.route === activeRoute || activeRoute.startsWith(page.route + "/");
                    return id({
                        isActive: isActive,
                        "linkProps": {
                            href: href,
                            "target": page.newWindow ? "_blank" : undefined
                        },
                        "text": page.title
                    });
                })
                    .filter(exclude(undefined)) })] }));
}
//# sourceMappingURL=navbar.js.map