import { jsx as _jsx } from "react/jsx-runtime";
import { useRouter } from "next/router";
import { useMounted } from "nextra/hooks";
import { useConfig } from "../contexts";
import { getGitIssueUrl, renderComponent } from "../utils";
import { Anchor } from "./anchor";
export function NotFoundPage() {
    var config = useConfig();
    var mounted = useMounted();
    var asPath = useRouter().asPath;
    var _a = config.notFound, content = _a.content, labels = _a.labels;
    if (!content) {
        return null;
    }
    return (_jsx("p", { className: "nx-text-center", children: _jsx(Anchor, { href: getGitIssueUrl({
                repository: config.docsRepositoryBase,
                title: "Found broken `".concat(mounted ? asPath : "", "` link. Please fix!"),
                labels: labels
            }), newWindow: true, className: "nx-text-primary-600 nx-underline nx-decoration-from-font [text-underline-position:from-font]", children: renderComponent(content) }) }));
}
//# sourceMappingURL=not-found.js.map