var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { Transition } from "@headlessui/react";
import cn from "clsx";
import { useRouter } from "next/router";
import { useMounted } from "nextra/hooks";
import { InformationCircleIcon, SpinnerIcon } from "nextra/icons";
import { Fragment, useCallback, useEffect, useRef, useState } from "react";
import { useConfig, useMenu } from "../contexts";
import { renderComponent, renderString } from "../utils";
import { Anchor } from "./anchor";
import { Input } from "./input";
var INPUTS = ["input", "select", "button", "textarea"];
export function Search(_a) {
    var className = _a.className, overlayClassName = _a.overlayClassName, value = _a.value, onChange = _a.onChange, onActive = _a.onActive, loading = _a.loading, error = _a.error, results = _a.results;
    var _b = __read(useState(false), 2), show = _b[0], setShow = _b[1];
    var config = useConfig();
    var _c = __read(useState(0), 2), active = _c[0], setActive = _c[1];
    var router = useRouter();
    var setMenu = useMenu().setMenu;
    var input = useRef(null);
    var ulRef = useRef(null);
    var _d = __read(useState(false), 2), focused = _d[0], setFocused = _d[1];
    useEffect(function () {
        setActive(0);
    }, [value]);
    useEffect(function () {
        var down = function (e) {
            var activeElement = document.activeElement;
            var tagName = activeElement === null || activeElement === void 0 ? void 0 : activeElement.tagName.toLowerCase();
            if (!input.current ||
                !tagName ||
                INPUTS.includes(tagName) ||
                (activeElement === null || activeElement === void 0 ? void 0 : activeElement.isContentEditable))
                return;
            if (e.key === "/" ||
                (e.key === "k" && (e.metaKey /* for Mac */ || /* for non-Mac */ e.ctrlKey))) {
                e.preventDefault();
                input.current.focus();
            }
            else if (e.key === "Escape") {
                setShow(false);
                input.current.blur();
            }
        };
        window.addEventListener("keydown", down);
        return function () {
            window.removeEventListener("keydown", down);
        };
    }, []);
    var finishSearch = useCallback(function () {
        var _a;
        (_a = input.current) === null || _a === void 0 ? void 0 : _a.blur();
        onChange("");
        setShow(false);
        setMenu(false);
    }, [onChange, setMenu]);
    var handleActive = useCallback(function (e) {
        var index = e.currentTarget.dataset.index;
        setActive(Number(index));
    }, []);
    var handleKeyDown = useCallback(function (e) {
        var _a, _b, _c;
        switch (e.key) {
            case "ArrowDown": {
                if (active + 1 < results.length) {
                    var el = (_a = ulRef.current) === null || _a === void 0 ? void 0 : _a.querySelector("li:nth-of-type(".concat(active + 2, ") > a"));
                    if (el) {
                        e.preventDefault();
                        handleActive({ currentTarget: el });
                        el.focus();
                    }
                }
                break;
            }
            case "ArrowUp": {
                if (active - 1 >= 0) {
                    var el = (_b = ulRef.current) === null || _b === void 0 ? void 0 : _b.querySelector("li:nth-of-type(".concat(active, ") > a"));
                    if (el) {
                        e.preventDefault();
                        handleActive({ currentTarget: el });
                        el.focus();
                    }
                }
                break;
            }
            case "Enter": {
                var result = results[active];
                if (result) {
                    void router.push(result.route);
                    finishSearch();
                }
                break;
            }
            case "Escape": {
                setShow(false);
                (_c = input.current) === null || _c === void 0 ? void 0 : _c.blur();
                break;
            }
        }
    }, [active, results, router, finishSearch, handleActive]);
    var mounted = useMounted();
    var renderList = show && Boolean(value);
    var icon = (_jsx(Transition, { show: mounted && (!show || Boolean(value)), as: Fragment, enter: "nx-transition-opacity", enterFrom: "nx-opacity-0", enterTo: "nx-opacity-100", leave: "nx-transition-opacity", leaveFrom: "nx-opacity-100", leaveTo: "nx-opacity-0", children: _jsx("kbd", { className: cn("nx-absolute nx-my-1.5 nx-select-none ltr:nx-right-1.5 rtl:nx-left-1.5", "nx-h-5 nx-rounded nx-bg-white nx-px-1.5 nx-font-mono nx-text-[10px] nx-font-medium nx-text-gray-500", "nx-border dark:nx-border-gray-100/20 dark:nx-bg-dark/50", "contrast-more:nx-border-current contrast-more:nx-text-current contrast-more:dark:nx-border-current", "nx-items-center nx-gap-1 nx-transition-opacity", value
                ? "nx-z-20 nx-flex nx-cursor-pointer hover:nx-opacity-70"
                : "nx-pointer-events-none nx-hidden sm:nx-flex"), title: value ? "Clear" : undefined, onClick: function () {
                onChange("");
            }, children: value && focused
                ? "ESC"
                : mounted &&
                    (navigator.userAgent.includes("Macintosh") ? (_jsxs(_Fragment, { children: [_jsx("span", { className: "nx-text-xs", children: "\u2318" }), "K"] })) : ("CTRL K")) }) }));
    return (_jsxs("div", { className: cn("nextra-search nx-relative md:nx-w-64", className), children: [renderList && (_jsx("div", { className: "nx-fixed nx-inset-0 nx-z-10", onClick: function () { return setShow(false); } })), _jsx(Input, { ref: input, value: value, onChange: function (e) {
                    var value = e.target.value;
                    onChange(value);
                    setShow(Boolean(value));
                }, onFocus: function () {
                    onActive === null || onActive === void 0 ? void 0 : onActive(true);
                    setFocused(true);
                }, onBlur: function () {
                    setFocused(false);
                }, type: "search", placeholder: renderString(config.search.placeholder), onKeyDown: handleKeyDown, suffix: icon }), _jsx(Transition, { show: renderList, 
                // Transition.Child is required here, otherwise popup will be still present in DOM after focus out
                as: Transition.Child, leave: "nx-transition-opacity nx-duration-100", leaveFrom: "nx-opacity-100", leaveTo: "nx-opacity-0", children: _jsx("ul", { className: cn("nextra-scrollbar", 
                    // Using bg-white as background-color when the browser didn't support backdrop-filter
                    "nx-border nx-border-gray-200 nx-bg-white nx-text-gray-100 dark:nx-border-neutral-800 dark:nx-bg-neutral-900", "nx-absolute nx-top-full nx-z-20 nx-mt-2 nx-overflow-auto nx-overscroll-contain nx-rounded-xl nx-py-2.5 nx-shadow-xl", "nx-max-h-[min(calc(50vh-11rem-env(safe-area-inset-bottom)),400px)]", "md:nx-max-h-[min(calc(100vh-5rem-env(safe-area-inset-bottom)),400px)]", "nx-inset-x-0 ltr:md:nx-left-auto rtl:md:nx-right-auto", "contrast-more:nx-border contrast-more:nx-border-gray-900 contrast-more:dark:nx-border-gray-50", overlayClassName), ref: ulRef, style: {
                        transition: "max-height .2s ease" // don't work with tailwindcss
                    }, children: error ? (_jsxs("span", { className: "nx-flex nx-select-none nx-justify-center nx-gap-2 nx-p-8 nx-text-center nx-text-sm nx-text-red-500", children: [_jsx(InformationCircleIcon, { className: "nx-h-5 nx-w-5" }), renderString(config.search.error)] })) : loading ? (_jsxs("span", { className: "nx-flex nx-select-none nx-justify-center nx-gap-2 nx-p-8 nx-text-center nx-text-sm nx-text-gray-400", children: [_jsx(SpinnerIcon, { className: "nx-h-5 nx-w-5 nx-animate-spin" }), renderComponent(config.search.loading)] })) : results.length > 0 ? (results.map(function (_a, i) {
                        var route = _a.route, prefix = _a.prefix, children = _a.children, id = _a.id;
                        return (_jsxs(Fragment, { children: [prefix, _jsx("li", { className: cn("nx-mx-2.5 nx-break-words nx-rounded-md", "contrast-more:nx-border", i === active
                                        ? "nx-bg-primary-500/10 nx-text-primary-600 contrast-more:nx-border-primary-500"
                                        : "nx-text-gray-800 contrast-more:nx-border-transparent dark:nx-text-gray-300"), children: _jsx(Anchor, { className: "nx-block nx-scroll-m-12 nx-px-2.5 nx-py-2", href: route, "data-index": i, onFocus: handleActive, onMouseMove: handleActive, onClick: finishSearch, onKeyDown: handleKeyDown, children: children }) })] }, id));
                    })) : (renderComponent(config.search.emptyResult)) }) })] }));
}
//# sourceMappingURL=search.js.map