var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import cn from "clsx";
import { useRouter } from "next/router";
import { useFSRoute } from "nextra/hooks";
import { ArrowRightIcon, ExpandIcon } from "nextra/icons";
import { createContext, memo, useContext, useEffect, useMemo, useRef, useState } from "react";
import scrollIntoView from "scroll-into-view-if-needed";
import { useActiveAnchor, useConfig, useMenu } from "../contexts";
import { renderComponent } from "../utils";
import { Anchor } from "./anchor";
import { Collapse } from "./collapse";
import { LocaleSwitch } from "./locale-switch";
var TreeState = Object.create(null);
var FocusedItemContext = createContext(null);
var OnFocusItemContext = createContext(null);
var FolderLevelContext = createContext(0);
var Folder = memo(function FolderInner(props) {
    var level = useContext(FolderLevelContext);
    return (_jsx(FolderLevelContext.Provider, { value: level + 1, children: _jsx(FolderImpl, __assign({}, props)) }));
});
var classes = {
    link: cn("nx-flex nx-rounded nx-px-2 nx-py-1.5 nx-text-sm nx-transition-colors [word-break:break-word]", "nx-cursor-pointer [-webkit-tap-highlight-color:transparent] [-webkit-touch-callout:none] contrast-more:nx-border"),
    inactive: cn("nx-text-gray-500 hover:nx-bg-gray-100 hover:nx-text-gray-900", "dark:nx-text-neutral-400 dark:hover:nx-bg-primary-100/5 dark:hover:nx-text-gray-50", "contrast-more:nx-text-gray-900 contrast-more:dark:nx-text-gray-50", "contrast-more:nx-border-transparent contrast-more:hover:nx-border-gray-900 contrast-more:dark:hover:nx-border-gray-50"),
    active: cn("nx-bg-primary-100 nx-font-semibold nx-text-primary-800 dark:nx-bg-primary-400/10 dark:nx-text-primary-600", "contrast-more:nx-border-primary-500 contrast-more:dark:nx-border-primary-500"),
    list: cn("nx-flex nx-flex-col nx-gap-1"),
    border: cn("nx-relative before:nx-absolute before:nx-inset-y-1", 'before:nx-w-px before:nx-bg-gray-200 before:nx-content-[""] dark:before:nx-bg-neutral-800', "ltr:nx-pl-3 ltr:before:nx-left-0 rtl:nx-pr-3 rtl:before:nx-right-0")
};
function FolderImpl(_a) {
    var item = _a.item, anchors = _a.anchors;
    var routeOriginal = useFSRoute();
    var _b = __read(routeOriginal.split("#"), 1), route = _b[0];
    var active = [route, route + "/"].includes(item.route + "/");
    var activeRouteInside = active || route.startsWith(item.route + "/");
    var focusedRoute = useContext(FocusedItemContext);
    var focusedRouteInside = !!(focusedRoute === null || focusedRoute === void 0 ? void 0 : focusedRoute.startsWith(item.route + "/"));
    var level = useContext(FolderLevelContext);
    var setMenu = useMenu().setMenu;
    var config = useConfig();
    var theme = item.theme;
    var open = TreeState[item.route] === undefined
        ? active ||
            activeRouteInside ||
            focusedRouteInside ||
            (theme && "collapsed" in theme
                ? !theme.collapsed
                : level < config.sidebar.defaultMenuCollapseLevel)
        : TreeState[item.route] || focusedRouteInside;
    var rerender = useState({})[1];
    useEffect(function () {
        var updateTreeState = function () {
            if (activeRouteInside || focusedRouteInside) {
                TreeState[item.route] = true;
            }
        };
        var updateAndPruneTreeState = function () {
            if (activeRouteInside && focusedRouteInside) {
                TreeState[item.route] = true;
            }
            else {
                delete TreeState[item.route];
            }
        };
        config.sidebar.autoCollapse ? updateAndPruneTreeState() : updateTreeState();
    }, [activeRouteInside, focusedRouteInside, item.route, config.sidebar.autoCollapse]);
    if (item.type === "menu") {
        var menu_1 = item;
        var routes_1 = Object.fromEntries((menu_1.children || []).map(function (route) { return [route.name, route]; }));
        item.children = Object.entries(menu_1.items || {}).map(function (_a) {
            var _b = __read(_a, 2), key = _b[0], item = _b[1];
            var route = routes_1[key] || __assign(__assign({ name: key }, ("locale" in menu_1 && { locale: menu_1.locale })), { route: menu_1.route + "/" + key });
            return __assign(__assign({}, route), item);
        });
    }
    var isLink = "withIndexPage" in item && item.withIndexPage;
    // use button when link don't have href because it impacts on SEO
    var ComponentToUse = isLink ? Anchor : "button";
    return (_jsxs("li", { className: cn({ open: open, active: active }), children: [_jsxs(ComponentToUse, { href: isLink ? item.route : undefined, className: cn("nx-items-center nx-justify-between nx-gap-2", !isLink && "nx-text-left nx-w-full", classes.link, active ? classes.active : classes.inactive), onClick: function (e) {
                    var clickedToggleIcon = ["svg", "path"].includes(e.target.tagName.toLowerCase());
                    if (clickedToggleIcon) {
                        e.preventDefault();
                    }
                    if (isLink) {
                        // If it's focused, we toggle it. Otherwise, always open it.
                        if (active || clickedToggleIcon) {
                            TreeState[item.route] = !open;
                        }
                        else {
                            TreeState[item.route] = true;
                            setMenu(false);
                        }
                        rerender({});
                        return;
                    }
                    if (active)
                        return;
                    TreeState[item.route] = !open;
                    rerender({});
                }, children: [renderComponent(config.sidebar.titleComponent, {
                        title: item.title,
                        type: item.type,
                        route: item.route
                    }), _jsx(ArrowRightIcon, { className: "nx-h-[18px] nx-min-w-[18px] nx-rounded-sm nx-p-0.5 hover:nx-bg-gray-800/5 dark:hover:nx-bg-gray-100/5", pathClassName: cn("nx-origin-center nx-transition-transform rtl:-nx-rotate-180", open && "ltr:nx-rotate-90 rtl:nx-rotate-[-270deg]") })] }), _jsx(Collapse, { className: "ltr:nx-pr-0 rtl:nx-pl-0 nx-pt-1", isOpen: open, children: Array.isArray(item.children) ? (_jsx(Menu, { className: cn(classes.border, "ltr:nx-ml-3 rtl:nx-mr-3"), directories: item.children, base: item.route, anchors: anchors })) : null })] }));
}
function Separator(_a) {
    var title = _a.title;
    var config = useConfig();
    return (_jsx("li", { className: cn("[word-break:break-word]", title
            ? "nx-mt-5 nx-mb-2 nx-px-2 nx-py-1.5 nx-text-sm nx-font-semibold nx-text-gray-900 first:nx-mt-0 dark:nx-text-gray-100"
            : "nx-my-4"), children: title ? (renderComponent(config.sidebar.titleComponent, {
            title: title,
            type: "separator",
            route: ""
        })) : (_jsx("hr", { className: "nx-mx-2 nx-border-t nx-border-gray-200 dark:nx-border-primary-100/10" })) }));
}
function File(_a) {
    var item = _a.item, anchors = _a.anchors;
    var route = useFSRoute();
    var onFocus = useContext(OnFocusItemContext);
    // It is possible that the item doesn't have any route - for example an external link.
    var active = item.route && [route, route + "/"].includes(item.route + "/");
    var activeAnchor = useActiveAnchor();
    var setMenu = useMenu().setMenu;
    var config = useConfig();
    if (item.type === "separator") {
        return _jsx(Separator, { title: item.title });
    }
    return (_jsxs("li", { className: cn(classes.list, { active: active }), children: [_jsx(Anchor, { href: item.href || item.route, newWindow: item.newWindow, className: cn(classes.link, active ? classes.active : classes.inactive), onClick: function () {
                    setMenu(false);
                }, onFocus: function () {
                    onFocus === null || onFocus === void 0 ? void 0 : onFocus(item.route);
                }, onBlur: function () {
                    onFocus === null || onFocus === void 0 ? void 0 : onFocus(null);
                }, children: renderComponent(config.sidebar.titleComponent, {
                    title: item.title,
                    type: item.type,
                    route: item.route
                }) }), active && anchors.length > 0 && (_jsx("ul", { className: cn(classes.list, classes.border, "ltr:nx-ml-3 rtl:nx-mr-3"), children: anchors.map(function (_a) {
                    var _b;
                    var id = _a.id, value = _a.value;
                    return (_jsx("li", { children: _jsx("a", { href: "#".concat(id), className: cn(classes.link, 'nx-flex nx-gap-2 before:nx-opacity-25 before:nx-content-["#"]', ((_b = activeAnchor[id]) === null || _b === void 0 ? void 0 : _b.isActive) ? classes.active : classes.inactive), onClick: function () {
                                setMenu(false);
                            }, children: value }) }, id));
                }) }))] }));
}
function Menu(_a) {
    var directories = _a.directories, anchors = _a.anchors, className = _a.className, onlyCurrentDocs = _a.onlyCurrentDocs;
    return (_jsx("ul", { className: cn(classes.list, className), children: directories.map(function (item) {
            return !onlyCurrentDocs || item.isUnderCurrentDocsTree ? (item.type === "menu" ||
                (item.children && (item.children.length || !item.withIndexPage)) ? (_jsx(Folder, { item: item, anchors: anchors }, item.name)) : (_jsx(File, { item: item, anchors: anchors }, item.name))) : null;
        }) }));
}
export function Sidebar(_a) {
    var docsDirectories = _a.docsDirectories, flatDirectories = _a.flatDirectories, fullDirectories = _a.fullDirectories, _b = _a.asPopover, asPopover = _b === void 0 ? false : _b, headings = _a.headings, includePlaceholder = _a.includePlaceholder;
    var config = useConfig();
    var _c = useMenu(), menu = _c.menu, setMenu = _c.setMenu;
    var router = useRouter();
    var _d = __read(useState(null), 2), focused = _d[0], setFocused = _d[1];
    var _e = __read(useState(true), 2), showSidebar = _e[0], setSidebar = _e[1];
    var _f = __read(useState(false), 2), showToggleAnimation = _f[0], setToggleAnimation = _f[1];
    var anchors = useMemo(function () { return headings.filter(function (v) { return v.depth === 2; }); }, [headings]);
    var sidebarRef = useRef(null);
    var containerRef = useRef(null);
    useEffect(function () {
        if (menu) {
            document.body.classList.add("nx-overflow-hidden", "md:nx-overflow-auto");
        }
        else {
            document.body.classList.remove("nx-overflow-hidden", "md:nx-overflow-auto");
        }
    }, [menu]);
    useEffect(function () {
        var _a;
        var activeElement = (_a = sidebarRef.current) === null || _a === void 0 ? void 0 : _a.querySelector("li.active");
        if (activeElement && (window.innerWidth > 767 || menu)) {
            var scroll_1 = function () {
                scrollIntoView(activeElement, {
                    block: "center",
                    inline: "center",
                    scrollMode: "always",
                    boundary: containerRef.current
                });
            };
            if (menu) {
                // needs for mobile since menu has transition transform
                setTimeout(scroll_1, 300);
            }
            else {
                scroll_1();
            }
        }
    }, [menu]);
    // Always close mobile nav when route was changed (e.g. logo click)
    useEffect(function () {
        setMenu(false);
    }, [router.asPath, setMenu]);
    var hasI18n = config.i18n.length > 0;
    var hasMenu = config.darkMode || hasI18n;
    return (_jsxs(_Fragment, { children: [includePlaceholder && asPopover ? (_jsx("div", { className: "max-xl:nx-hidden nx-h-0 nx-w-64 nx-shrink-0" })) : null, _jsx("div", { className: cn("motion-reduce:nx-transition-none [transition:background-color_1.5s_ease]", menu
                    ? "nx-fixed nx-inset-0 nx-z-10 nx-bg-black/80 dark:nx-bg-black/60"
                    : "nx-bg-transparent"), onClick: function () { return setMenu(false); } }), _jsxs("aside", { className: cn("nextra-sidebar-container nx-flex nx-flex-col", "md:nx-top-16 md:nx-shrink-0 motion-reduce:nx-transform-none", "nx-transform-gpu nx-transition-all nx-ease-in-out", "print:nx-hidden", showSidebar ? "md:nx-w-64" : "md:nx-w-20", asPopover ? "md:nx-hidden" : "md:nx-sticky md:nx-self-start", menu
                    ? "max-md:[transform:translate3d(0,0,0)]"
                    : "max-md:[transform:translate3d(0,-100%,0)]"), ref: containerRef, children: [_jsx("div", { className: "nx-px-4 nx-pt-4 md:nx-hidden", children: renderComponent(config.search.component, {
                            directories: flatDirectories
                        }) }), _jsx(FocusedItemContext.Provider, { value: focused, children: _jsx(OnFocusItemContext.Provider, { value: function (item) {
                                setFocused(item);
                            }, children: _jsxs("div", { className: cn("nx-overflow-y-auto nx-overflow-x-hidden", "nx-p-4 nx-grow md:nx-h-[calc(100vh-var(--nextra-navbar-height)-var(--nextra-menu-height))]", showSidebar ? "nextra-scrollbar" : "no-scrollbar"), ref: sidebarRef, children: [(!asPopover || !showSidebar) && (_jsx(Collapse, { isOpen: showSidebar, horizontal: true, children: _jsx(Menu, { className: "max-md:nx-hidden", 
                                            // The sidebar menu, shows only the docs directories.
                                            directories: docsDirectories, 
                                            // When the viewport size is larger than `md`, hide the anchors in
                                            // the sidebar when `floatTOC` is enabled.
                                            anchors: config.toc.float ? [] : anchors, onlyCurrentDocs: true }) })), _jsx(Menu, { className: "md:nx-hidden", 
                                        // The mobile dropdown menu, shows all the directories.
                                        directories: fullDirectories, 
                                        // Always show the anchor links on mobile (`md`).
                                        anchors: anchors })] }) }) }), hasMenu && (_jsxs("div", { className: cn("nx-sticky nx-bottom-0", "nx-bg-white dark:nx-bg-dark", // when banner is showed, sidebar links can be behind menu, set bg color as body bg color
                        "nx-mx-4 nx-py-4 nx-shadow-[0_-12px_16px_#fff]", "nx-flex nx-items-center nx-gap-2", "dark:nx-border-neutral-800 dark:nx-shadow-[0_-12px_16px_#111]", "contrast-more:nx-border-neutral-400 contrast-more:nx-shadow-none contrast-more:dark:nx-shadow-none", showSidebar
                            ? cn(hasI18n && "nx-justify-end", "nx-border-t")
                            : "nx-py-4 nx-flex-wrap nx-justify-center"), "data-toggle-animation": showToggleAnimation ? (showSidebar ? "show" : "hide") : "off", children: [hasI18n && (_jsx(LocaleSwitch, { options: config.i18n, lite: !showSidebar, className: cn(showSidebar ? "nx-grow" : "max-md:nx-grow") })), config.darkMode && (_jsx("div", { className: showSidebar && !hasI18n ? "nx-grow nx-flex nx-flex-col" : "", children: renderComponent(config.themeSwitch.component, {
                                    lite: !showSidebar || hasI18n
                                }) })), config.sidebar.toggleButton && (_jsx("button", { title: showSidebar ? "Hide sidebar" : "Show sidebar", className: "max-md:nx-hidden nx-h-7 nx-rounded-md nx-transition-colors nx-text-gray-600 dark:nx-text-gray-400 nx-px-2 hover:nx-bg-gray-100 hover:nx-text-gray-900 dark:hover:nx-bg-primary-100/5 dark:hover:nx-text-gray-50", onClick: function () {
                                    setSidebar(!showSidebar);
                                    setToggleAnimation(true);
                                }, children: _jsx(ExpandIcon, { isOpen: showSidebar }) }))] }))] })] }));
}
//# sourceMappingURL=sidebar.js.map