import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useTheme } from "next-themes";
import { useMounted } from "nextra/hooks";
import { MoonIcon, SunIcon } from "nextra/icons";
import { z } from "zod";
import { useConfig } from "../contexts";
import { Select } from "./select";
export var themeOptionsSchema = z.strictObject({
    light: z.string(),
    dark: z.string(),
    system: z.string()
});
export function ThemeSwitch(_a) {
    var lite = _a.lite, className = _a.className;
    var _b = useTheme(), setTheme = _b.setTheme, resolvedTheme = _b.resolvedTheme, _c = _b.theme, theme = _c === void 0 ? "" : _c;
    var mounted = useMounted();
    var config = useConfig().themeSwitch;
    var IconToUse = mounted && resolvedTheme === "dark" ? MoonIcon : SunIcon;
    var options = typeof config.useOptions === "function" ? config.useOptions() : config.useOptions;
    return (_jsx(Select, { className: className, title: "Change theme", options: [
            { key: "light", name: options.light },
            { key: "dark", name: options.dark },
            { key: "system", name: options.system }
        ], onChange: function (option) {
            setTheme(option.key);
        }, selected: {
            key: theme,
            name: (_jsxs("div", { className: "nx-flex nx-items-center nx-gap-2 nx-capitalize", children: [_jsx(IconToUse, {}), _jsx("span", { className: lite ? "md:nx-hidden" : "", children: mounted ? options[theme] : options.light })] }))
        } }));
}
//# sourceMappingURL=theme-switch.js.map