var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import cn from "clsx";
import { useEffect, useMemo, useRef } from "react";
import scrollIntoView from "scroll-into-view-if-needed";
import { useActiveAnchor, useConfig } from "../contexts";
import { renderComponent } from "../utils";
import { Anchor } from "./anchor";
var linkClassName = cn("nx-text-xs nx-font-medium nx-text-gray-500 hover:nx-text-gray-900 dark:nx-text-gray-400 dark:hover:nx-text-gray-100", "contrast-more:nx-text-gray-800 contrast-more:dark:nx-text-gray-50");
export function TOC(_a) {
    var _b;
    var headings = _a.headings, filePath = _a.filePath;
    var activeAnchor = useActiveAnchor();
    var config = useConfig();
    var tocRef = useRef(null);
    var items = useMemo(function () { return headings.filter(function (heading) { return heading.depth > 1; }); }, [headings]);
    var hasHeadings = items.length > 0;
    var hasMetaInfo = Boolean(config.feedback.content || config.editLink.component || config.toc.extraContent);
    var activeSlug = (_b = Object.entries(activeAnchor).find(function (_a) {
        var _b = __read(_a, 2), isActive = _b[1].isActive;
        return isActive;
    })) === null || _b === void 0 ? void 0 : _b[0];
    useEffect(function () {
        var _a;
        if (!activeSlug)
            return;
        var anchor = (_a = tocRef.current) === null || _a === void 0 ? void 0 : _a.querySelector("li > a[href=\"#".concat(activeSlug, "\"]"));
        if (anchor) {
            scrollIntoView(anchor, {
                behavior: "smooth",
                block: "center",
                inline: "center",
                scrollMode: "always",
                boundary: tocRef.current
            });
        }
    }, [activeSlug]);
    return (_jsxs("div", { ref: tocRef, className: cn("nextra-scrollbar nx-sticky nx-top-16 nx-overflow-y-auto nx-pr-4 nx-pt-6 nx-text-sm [hyphens:auto]", "nx-max-h-[calc(100vh-var(--nextra-navbar-height)-env(safe-area-inset-bottom))] ltr:-nx-mr-4 rtl:-nx-ml-4"), children: [hasHeadings && (_jsxs(_Fragment, { children: [_jsx("p", { className: "nx-mb-4 nx-font-semibold nx-tracking-tight", children: renderComponent(config.toc.title) }), _jsx("ul", { children: items.map(function (_a) {
                            var _b, _c, _d, _e;
                            var id = _a.id, value = _a.value, depth = _a.depth;
                            return (_jsx("li", { className: "nx-my-2 nx-scroll-my-6 nx-scroll-py-6", children: _jsx("a", { href: "#".concat(id), className: cn({
                                        2: "nx-font-semibold",
                                        3: "ltr:nx-pl-4 rtl:nx-pr-4",
                                        4: "ltr:nx-pl-8 rtl:nx-pr-8",
                                        5: "ltr:nx-pl-12 rtl:nx-pr-12",
                                        6: "ltr:nx-pl-16 rtl:nx-pr-16"
                                    }[depth], "nx-inline-block", ((_b = activeAnchor[id]) === null || _b === void 0 ? void 0 : _b.isActive)
                                        ? "nx-text-primary-600 nx-subpixel-antialiased contrast-more:!nx-text-primary-600"
                                        : "nx-text-gray-500 hover:nx-text-gray-900 dark:nx-text-gray-400 dark:hover:nx-text-gray-300", "contrast-more:nx-text-gray-900 contrast-more:nx-underline contrast-more:dark:nx-text-gray-50 nx-w-full nx-break-words"), children: (_e = (_d = (_c = config.toc).headingComponent) === null || _d === void 0 ? void 0 : _d.call(_c, {
                                        id: id,
                                        children: value
                                    })) !== null && _e !== void 0 ? _e : value }) }, id));
                        }) })] })), hasMetaInfo && (_jsxs("div", { className: cn(hasHeadings &&
                    "nx-mt-8 nx-border-t nx-bg-white nx-pt-8 nx-shadow-[0_-12px_16px_white] dark:nx-bg-dark dark:nx-shadow-[0_-12px_16px_#111]", "nx-sticky nx-bottom-0 nx-flex nx-flex-col nx-items-start nx-gap-2 nx-pb-8 dark:nx-border-neutral-800", "contrast-more:nx-border-t contrast-more:nx-border-neutral-400 contrast-more:nx-shadow-none contrast-more:dark:nx-border-neutral-400"), children: [config.feedback.content ? (_jsx(Anchor, { className: linkClassName, href: config.feedback.useLink(), newWindow: true, children: renderComponent(config.feedback.content) })) : null, renderComponent(config.editLink.component, {
                        filePath: filePath,
                        className: linkClassName,
                        children: renderComponent(config.editLink.text)
                    }), renderComponent(config.toc.extraContent)] }))] }));
}
//# sourceMappingURL=toc.js.map