var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { useRouter } from "next/router";
import { DiscordIcon, GitHubIcon } from "nextra/icons";
import { isValidElement } from "react";
import { z } from "zod";
import { Anchor, Flexsearch, Footer, Navbar, TOC } from "./components";
import { MatchSorterSearch } from "./components/match-sorter-search";
import { themeOptionsSchema, ThemeSwitch } from "./components/theme-switch";
import { useConfig } from "./contexts";
import { getGitIssueUrl, useGitEditUrl } from "./utils";
export var DEFAULT_LOCALE = "fr";
export var IS_BROWSER = typeof window !== "undefined";
function isReactNode(value) {
    return value == null || isString(value) || isFunction(value) || isValidElement(value);
}
function isFunction(value) {
    return typeof value === "function";
}
function isString(value) {
    return typeof value === "string";
}
var i18nSchema = z.array(z.strictObject({
    direction: z.enum(["ltr", "rtl"]).optional(),
    locale: z.string(),
    text: z.string()
}));
var reactNode = [isReactNode, { message: "Must be React.ReactNode or React.FC" }];
var fc = [isFunction, { message: "Must be React.FC" }];
export var themeSchema = z.strictObject({
    banner: z.strictObject({
        dismissible: z.boolean(),
        key: z.string(),
        text: z.custom.apply(z, __spreadArray([], __read(reactNode), false)).optional()
    }),
    chat: z.strictObject({
        icon: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        link: z.string().startsWith("https://").optional()
    }),
    components: z.record(z.custom.apply(z, __spreadArray([], __read(fc), false))).optional(),
    darkMode: z.boolean(),
    direction: z.enum(["ltr", "rtl"]),
    docsRepositoryBase: z.string().startsWith("https://"),
    editLink: z.strictObject({
        component: z.custom.apply(z, __spreadArray([], __read(fc), false)),
        text: z.custom.apply(z, __spreadArray([], __read(reactNode), false))
    }),
    faviconGlyph: z.string().optional(),
    feedback: z.strictObject({
        content: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        labels: z.string(),
        useLink: z.function().returns(z.string())
    }),
    footer: z.strictObject({
        component: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        text: z.custom.apply(z, __spreadArray([], __read(reactNode), false))
    }),
    gitTimestamp: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
    head: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
    i18n: i18nSchema,
    main: z.custom.apply(z, __spreadArray([], __read(fc), false)).optional(),
    navbar: z.strictObject({
        component: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        extraContent: z.custom.apply(z, __spreadArray([], __read(reactNode), false)).optional()
    }),
    navigation: z.boolean().or(z.strictObject({
        next: z.boolean(),
        prev: z.boolean()
    })),
    nextThemes: z.strictObject({
        defaultTheme: z.string(),
        forcedTheme: z.string().optional(),
        storageKey: z.string()
    }),
    notFound: z.strictObject({
        content: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        labels: z.string()
    }),
    primaryHue: z.number().or(z.strictObject({
        dark: z.number(),
        light: z.number()
    })),
    project: z.strictObject({
        icon: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        link: z.string().startsWith("https://").optional()
    }),
    search: z.strictObject({
        component: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        emptyResult: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        error: z.string().or(z.function().returns(z.string())),
        loading: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        // Can't be React component
        placeholder: z.string().or(z.function().returns(z.string()))
    }),
    serverSideError: z.strictObject({
        content: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        labels: z.string()
    }),
    sidebar: z.strictObject({
        autoCollapse: z.boolean().optional(),
        defaultMenuCollapseLevel: z.number().min(1).int(),
        titleComponent: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        toggleButton: z.boolean()
    }),
    themeSwitch: z.strictObject({
        component: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        useOptions: themeOptionsSchema.or(z.function().returns(themeOptionsSchema))
    }),
    toc: z.strictObject({
        component: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        extraContent: z.custom.apply(z, __spreadArray([], __read(reactNode), false)),
        float: z.boolean(),
        headingComponent: z.custom.apply(z, __spreadArray([], __read(fc), false)).optional(),
        title: z.custom.apply(z, __spreadArray([], __read(reactNode), false))
    }),
    useNextSeoProps: z.custom(isFunction)
});
var publicThemeSchema = themeSchema.deepPartial().extend({
    // to have `locale` and `text` as required properties
    i18n: i18nSchema.optional()
});
var LOADING_LOCALES = {
    "en-US": "Loading",
    fr: "Сhargement",
    ru: "Загрузка",
    "zh-CN": "正在加载"
};
var PLACEHOLDER_LOCALES = {
    "en-US": "Search documentation",
    fr: "Rechercher documents",
    ru: "Поиск документации",
    "zh-CN": "搜索文档"
};
export var DEFAULT_THEME = {
    banner: {
        dismissible: true,
        key: "nextra-banner"
    },
    chat: {
        icon: (_jsxs(_Fragment, { children: [_jsx(DiscordIcon, {}), _jsx("span", { className: "nx-sr-only", children: "Discord" })] }))
    },
    darkMode: true,
    direction: "ltr",
    docsRepositoryBase: "https://github.com/shuding/nextra",
    editLink: {
        component: function EditLink(_a) {
            var className = _a.className, filePath = _a.filePath, children = _a.children;
            var editUrl = useGitEditUrl(filePath);
            if (!editUrl) {
                return null;
            }
            return (_jsx(Anchor, { className: className, href: editUrl, children: children }));
        },
        text: "Edit this page"
    },
    feedback: {
        content: "Question? Give us feedback →",
        labels: "feedback",
        useLink: function () {
            var config = useConfig();
            return getGitIssueUrl({
                labels: config.feedback.labels,
                repository: config.docsRepositoryBase,
                title: "Feedback for \u201C".concat(config.title, "\u201D")
            });
        }
    },
    footer: {
        component: Footer,
        text: "MIT ".concat(new Date().getFullYear(), " \u00A9 Nextra.")
    },
    gitTimestamp: function GitTimestamp(_a) {
        var timestamp = _a.timestamp;
        var _b = useRouter().locale, locale = _b === void 0 ? DEFAULT_LOCALE : _b;
        return (_jsxs(_Fragment, { children: ["Last updated on", " ", _jsx("time", { dateTime: timestamp.toISOString(), children: timestamp.toLocaleDateString(locale, {
                        day: "numeric",
                        month: "long",
                        year: "numeric"
                    }) })] }));
    },
    head: (_jsxs(_Fragment, { children: [_jsx("meta", { name: "msapplication-TileColor", content: "#fff" }), _jsx("meta", { httpEquiv: "Content-Language", content: "en" }), _jsx("meta", { name: "description", content: "Nextra: the next docs builder" }), _jsx("meta", { name: "twitter:card", content: "summary_large_image" }), _jsx("meta", { name: "twitter:site", content: "@shuding_" }), _jsx("meta", { property: "og:title", content: "Nextra: the next docs builder" }), _jsx("meta", { property: "og:description", content: "Nextra: the next docs builder" }), _jsx("meta", { name: "apple-mobile-web-app-title", content: "Nextra" })] })),
    i18n: [],
    navbar: {
        component: Navbar
    },
    navigation: true,
    nextThemes: {
        defaultTheme: "system",
        storageKey: "theme"
    },
    notFound: {
        content: "Submit an issue about broken link →",
        labels: "bug"
    },
    primaryHue: {
        dark: 204,
        light: 212
    },
    project: {
        icon: (_jsxs(_Fragment, { children: [_jsx(GitHubIcon, {}), _jsx("span", { className: "nx-sr-only", children: "GitHub" })] }))
    },
    search: {
        component: function Search(_a) {
            var className = _a.className, directories = _a.directories;
            var config = useConfig();
            return config.flexsearch ? (_jsx(Flexsearch, { className: className })) : (_jsx(MatchSorterSearch, { className: className, directories: directories }));
        },
        emptyResult: (_jsx("span", { className: "nx-block nx-select-none nx-p-8 nx-text-center nx-text-sm nx-text-gray-400", children: "No results found." })),
        error: "Failed to load search index.",
        loading: function useLoading() {
            var _a = useRouter(), locale = _a.locale, _b = _a.defaultLocale, defaultLocale = _b === void 0 ? DEFAULT_LOCALE : _b;
            var text = (locale && LOADING_LOCALES[locale]) || LOADING_LOCALES[defaultLocale];
            return _jsxs(_Fragment, { children: [text, "\u2026"] });
        },
        placeholder: function usePlaceholder() {
            var _a = useRouter(), locale = _a.locale, _b = _a.defaultLocale, defaultLocale = _b === void 0 ? DEFAULT_LOCALE : _b;
            var text = (locale && PLACEHOLDER_LOCALES[locale]) || PLACEHOLDER_LOCALES[defaultLocale];
            return "".concat(text, "\u2026");
        }
    },
    serverSideError: {
        content: "Submit an issue about error in url →",
        labels: "bug"
    },
    sidebar: {
        defaultMenuCollapseLevel: 2,
        titleComponent: function (_a) {
            var title = _a.title;
            return _jsx(_Fragment, { children: title });
        },
        toggleButton: false
    },
    themeSwitch: {
        component: ThemeSwitch,
        useOptions: function () {
            var locale = useRouter().locale;
            if (locale === "zh-CN") {
                return { dark: "深色主题", light: "浅色主题", system: "系统默认" };
            }
            return { dark: "Dark", light: "Light", system: "System" };
        }
    },
    toc: {
        component: TOC,
        float: true,
        title: "On This Page"
    },
    useNextSeoProps: function () { return ({ titleTemplate: "%s – Nextra" }); }
};
export var DEEP_OBJECT_KEYS = Object.entries(DEFAULT_THEME)
    .map(function (_a) {
    var _b = __read(_a, 2), key = _b[0], value = _b[1];
    var isObject = value && typeof value === "object" && !Array.isArray(value) && !isValidElement(value);
    if (isObject) {
        return key;
    }
})
    .filter(Boolean);
//# sourceMappingURL=constants.js.map