var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { jsx as _jsx } from "react/jsx-runtime";
import "intersection-observer";
import { createContext, useContext, useRef, useState } from "react";
import { IS_BROWSER } from "../constants";
var ActiveAnchorContext = createContext({});
var SetActiveAnchorContext = createContext(function (v) { return v; });
var IntersectionObserverContext = createContext(null);
var slugs = new WeakMap();
var SlugsContext = createContext(slugs);
// Separate the state as 2 contexts here to avoid
// re-renders of the content triggered by the state update.
export var useActiveAnchor = function () { return useContext(ActiveAnchorContext); };
export var useSetActiveAnchor = function () { return useContext(SetActiveAnchorContext); };
export var useIntersectionObserver = function () { return useContext(IntersectionObserverContext); };
export var useSlugs = function () { return useContext(SlugsContext); };
export var ActiveAnchorProvider = function (_a) {
    var children = _a.children;
    var _b = __read(useState({}), 2), activeAnchor = _b[0], setActiveAnchor = _b[1];
    var observerRef = useRef(null);
    if (IS_BROWSER && !observerRef.current) {
        observerRef.current = new IntersectionObserver(function (entries) {
            setActiveAnchor(function (f) {
                var e_1, _a;
                var ret = __assign({}, f);
                try {
                    for (var entries_1 = __values(entries), entries_1_1 = entries_1.next(); !entries_1_1.done; entries_1_1 = entries_1.next()) {
                        var entry = entries_1_1.value;
                        if ((entry === null || entry === void 0 ? void 0 : entry.rootBounds) && slugs.has(entry.target)) {
                            var _b = __read(slugs.get(entry.target), 2), slug = _b[0], index = _b[1];
                            var aboveHalfViewport = entry.boundingClientRect.y + entry.boundingClientRect.height <=
                                entry.rootBounds.y + entry.rootBounds.height;
                            var insideHalfViewport = entry.intersectionRatio > 0;
                            ret[slug] = {
                                index: index,
                                aboveHalfViewport: aboveHalfViewport,
                                insideHalfViewport: insideHalfViewport
                            };
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (entries_1_1 && !entries_1_1.done && (_a = entries_1.return)) _a.call(entries_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                var activeSlug = "";
                var smallestIndexInViewport = Infinity;
                var largestIndexAboveViewport = -1;
                for (var s in ret) {
                    ret[s].isActive = false;
                    if (ret[s].insideHalfViewport && ret[s].index < smallestIndexInViewport) {
                        smallestIndexInViewport = ret[s].index;
                        activeSlug = s;
                    }
                    if (smallestIndexInViewport === Infinity &&
                        ret[s].aboveHalfViewport &&
                        ret[s].index > largestIndexAboveViewport) {
                        largestIndexAboveViewport = ret[s].index;
                        activeSlug = s;
                    }
                }
                if (ret[activeSlug])
                    ret[activeSlug].isActive = true;
                return ret;
            });
        }, {
            rootMargin: "0px 0px -50%",
            threshold: [0, 1]
        });
    }
    return (_jsx(ActiveAnchorContext.Provider, { value: activeAnchor, children: _jsx(SetActiveAnchorContext.Provider, { value: setActiveAnchor, children: _jsx(SlugsContext.Provider, { value: slugs, children: _jsx(IntersectionObserverContext.Provider, { value: observerRef.current, children: children }) }) }) }));
};
//# sourceMappingURL=active-anchor.js.map