var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { jsx as _jsx } from "react/jsx-runtime";
import { ThemeProvider } from "next-themes";
import { metaSchema } from "nextra/normalize-pages";
import { createContext, useContext, useState } from "react";
import { DEEP_OBJECT_KEYS, DEFAULT_THEME, themeSchema } from "../constants";
import { MenuProvider } from "./menu";
var ConfigContext = createContext(__assign({ title: "", frontMatter: {} }, DEFAULT_THEME));
export function useConfig() {
    // @ts-expect-error TODO: fix Type 'Config<{ [key: string]: any; }>' is not assignable to type 'Config<FrontMatterType>'.
    return useContext(ConfigContext);
}
var theme;
var isValidated = false;
function normalizeZodMessage(error) {
    return error.issues
        .flatMap(function (issue) {
        var themePath = issue.path.length > 0 && "Path: \"".concat(issue.path.join("."), "\"");
        var unionErrors = "unionErrors" in issue ? issue.unionErrors.map(normalizeZodMessage) : [];
        return __spreadArray([[issue.message, themePath].filter(Boolean).join(". ")], __read(unionErrors), false);
    })
        .join("\n");
}
function validateMeta(pageMap) {
    var e_1, _a, e_2, _b;
    try {
        for (var pageMap_1 = __values(pageMap), pageMap_1_1 = pageMap_1.next(); !pageMap_1_1.done; pageMap_1_1 = pageMap_1.next()) {
            var pageMapItem = pageMap_1_1.value;
            if (pageMapItem.kind === "Meta") {
                try {
                    for (var _c = (e_2 = void 0, __values(Object.entries(pageMapItem.data))), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var _e = __read(_d.value, 2), key = _e[0], data = _e[1];
                        try {
                            metaSchema.parse(data);
                        }
                        catch (error) {
                            console.error("[nextra-theme-docs] Error validating _meta.json file for \"".concat(key, "\" property.\n\n").concat(normalizeZodMessage(error)));
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            else if (pageMapItem.kind === "Folder") {
                validateMeta(pageMapItem.children);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (pageMap_1_1 && !pageMap_1_1.done && (_a = pageMap_1.return)) _a.call(pageMap_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
export var ConfigProvider = function (_a) {
    var children = _a.children, _b = _a.value, themeConfig = _b.themeConfig, pageOpts = _b.pageOpts;
    var _c = __read(useState(false), 2), menu = _c[0], setMenu = _c[1];
    // Merge only on first load
    theme || (theme = __assign(__assign({}, DEFAULT_THEME), Object.fromEntries(Object.entries(themeConfig).map(function (_a) {
        var _b = __read(_a, 2), key = _b[0], value = _b[1];
        return [
            key,
            value && typeof value === "object" && DEEP_OBJECT_KEYS.includes(key)
                ? // @ts-expect-error -- key has always object value
                 __assign(__assign({}, DEFAULT_THEME[key]), value) : value
        ];
    }))));
    if (process.env.NODE_ENV !== "production" && !isValidated) {
        try {
            themeSchema.parse(theme);
        }
        catch (error) {
            console.error("[nextra-theme-docs] Error validating theme config file.\n\n".concat(normalizeZodMessage(error)));
        }
        validateMeta(pageOpts.pageMap);
        isValidated = true;
    }
    var extendedConfig = __assign(__assign(__assign(__assign({}, theme), { flexsearch: pageOpts.flexsearch }), (typeof pageOpts.newNextLinkBehavior === "boolean" && {
        newNextLinkBehavior: pageOpts.newNextLinkBehavior
    })), { title: pageOpts.title, frontMatter: pageOpts.frontMatter });
    var nextThemes = extendedConfig.nextThemes;
    return (_jsx(ThemeProvider, { attribute: "class", disableTransitionOnChange: true, defaultTheme: nextThemes.defaultTheme, storageKey: nextThemes.storageKey, forcedTheme: nextThemes.forcedTheme, children: _jsx(ConfigContext.Provider, { value: extendedConfig, children: _jsx(MenuProvider, { value: { menu: menu, setMenu: setMenu }, children: children }) }) }));
};
//# sourceMappingURL=config.js.map