var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { useRouter } from "next/router";
import { useMemo } from "react";
import "focus-visible";
import cn from "clsx";
import { useFSRoute, useMounted } from "nextra/hooks";
import { MDXProvider } from "nextra/mdx";
import "./polyfill";
import { normalizePages } from "nextra/normalize-pages";
import { Banner, Breadcrumb, Head, NavLinks, Sidebar, SkipNavContent } from "./components";
import { DEFAULT_LOCALE } from "./constants";
import { ActiveAnchorProvider, ConfigProvider, useConfig } from "./contexts";
import { getComponents } from "./mdx-components";
import { renderComponent } from "./utils";
var classes = {
    toc: cn("nextra-toc nx-order-last nx-hidden nx-w-64 nx-shrink-0 xl:nx-block print:nx-hidden"),
    main: cn("nx-w-full nx-break-words")
};
var Body = function (_a) {
    var _b;
    var themeContext = _a.themeContext, breadcrumb = _a.breadcrumb, timestamp = _a.timestamp, navigation = _a.navigation, children = _a.children;
    var config = useConfig();
    var mounted = useMounted();
    if (themeContext.layout === "raw") {
        return _jsx("div", { className: classes.main, children: children });
    }
    var date = themeContext.timestamp && config.gitTimestamp && timestamp ? new Date(timestamp) : null;
    var gitTimestampEl = 
    // Because a user's time zone may be different from the server page
    mounted && date ? (_jsx("div", { className: "nx-mt-12 nx-mb-8 nx-block nx-text-xs nx-text-gray-500 ltr:nx-text-right rtl:nx-text-left dark:nx-text-gray-400", children: renderComponent(config.gitTimestamp, { timestamp: date }) })) : (_jsx("div", { className: "nx-mt-16" }));
    var content = (_jsxs(_Fragment, { children: [children, gitTimestampEl, navigation] }));
    var body = ((_b = config.main) === null || _b === void 0 ? void 0 : _b.call(config, { children: content })) || content;
    if (themeContext.layout === "full") {
        return (_jsx("article", { className: cn(classes.main, "nextra-content nx-min-h-[calc(100vh-var(--nextra-navbar-height))] nx-pl-[max(env(safe-area-inset-left),1.5rem)] nx-pr-[max(env(safe-area-inset-right),1.5rem)]"), children: body }));
    }
    return (_jsx("article", { className: cn(classes.main, "nextra-content nx-flex nx-min-h-[calc(100vh-var(--nextra-navbar-height))] nx-min-w-0 nx-justify-center nx-pb-8 nx-pr-[calc(env(safe-area-inset-right)-1.5rem)]", themeContext.typesetting === "article" && "nextra-body-typesetting-article"), children: _jsxs("main", { className: "nx-w-full nx-min-w-0 nx-max-w-6xl nx-px-6 nx-pt-4 md:nx-px-12", children: [breadcrumb, body] }) }));
};
var InnerLayout = function (_a) {
    var filePath = _a.filePath, pageMap = _a.pageMap, frontMatter = _a.frontMatter, headings = _a.headings, timestamp = _a.timestamp, children = _a.children;
    var config = useConfig();
    var _b = useRouter(), _c = _b.locale, locale = _c === void 0 ? DEFAULT_LOCALE : _c, defaultLocale = _b.defaultLocale;
    var fsPath = useFSRoute();
    var _d = useMemo(function () {
        return normalizePages({
            list: pageMap,
            locale: locale,
            defaultLocale: defaultLocale,
            route: fsPath
        });
    }, [pageMap, locale, defaultLocale, fsPath]), activeType = _d.activeType, activeIndex = _d.activeIndex, activeThemeContext = _d.activeThemeContext, activePath = _d.activePath, topLevelNavbarItems = _d.topLevelNavbarItems, docsDirectories = _d.docsDirectories, flatDirectories = _d.flatDirectories, flatDocsDirectories = _d.flatDocsDirectories, directories = _d.directories;
    var themeContext = __assign(__assign({}, activeThemeContext), frontMatter);
    var hideSidebar = !themeContext.sidebar || themeContext.layout === "raw" || activeType === "page";
    var tocEl = activeType === "page" || !themeContext.toc || themeContext.layout !== "default" ? (themeContext.layout !== "full" &&
        themeContext.layout !== "raw" && (_jsx("nav", { className: classes.toc, "aria-label": "table of contents" }))) : (_jsx("nav", { className: cn(classes.toc, "nx-px-4"), "aria-label": "table of contents", children: renderComponent(config.toc.component, {
            headings: config.toc.float ? headings : [],
            filePath: filePath
        }) }));
    var localeConfig = config.i18n.find(function (l) { return l.locale === locale; });
    var isRTL = localeConfig ? localeConfig.direction === "rtl" : config.direction === "rtl";
    var direction = isRTL ? "rtl" : "ltr";
    return (
    // This makes sure that selectors like `[dir=ltr] .nextra-container` work
    // before hydration as Tailwind expects the `dir` attribute to exist on the
    // `html` element.
    _jsxs("div", { dir: direction, style: {
            minHeight: "100vh",
            display: "flex",
            flexDirection: "column"
        }, children: [_jsx("script", { dangerouslySetInnerHTML: {
                    __html: "document.documentElement.setAttribute('dir','".concat(direction, "')")
                } }), _jsx(Head, {}), _jsx(Banner, {}), themeContext.navbar &&
                renderComponent(config.navbar.component, {
                    flatDirectories: flatDirectories,
                    items: topLevelNavbarItems
                }), _jsx("div", { className: cn("nx-mx-auto nx-flex", themeContext.layout !== "raw" && "nx-max-w-[90rem]"), children: _jsxs(ActiveAnchorProvider, { children: [_jsx(Sidebar, { docsDirectories: docsDirectories, flatDirectories: flatDirectories, fullDirectories: directories, headings: headings, asPopover: hideSidebar, includePlaceholder: themeContext.layout === "default" }), tocEl, _jsx(SkipNavContent, {}), _jsx(Body, { themeContext: themeContext, breadcrumb: activeType !== "page" && themeContext.breadcrumb ? (_jsx(Breadcrumb, { activePath: activePath })) : null, timestamp: timestamp, navigation: activeType !== "page" && themeContext.pagination ? (_jsx(NavLinks, { flatDirectories: flatDocsDirectories, currentIndex: activeIndex })) : null, children: _jsx(MDXProvider, { components: getComponents({
                                    isRawLayout: themeContext.layout === "raw",
                                    components: config.components
                                }), children: children }) })] }) }), themeContext.footer && renderComponent(config.footer.component, { menu: hideSidebar })] }));
};
export default function Layout(_a) {
    var children = _a.children, context = __rest(_a, ["children"]);
    return (_jsx(ConfigProvider, { value: context, children: _jsx(InnerLayout, __assign({}, context.pageOpts, { children: children })) }));
}
export { useConfig };
export { useMDXComponents } from "nextra/mdx";
export { Callout } from "nextra/components";
export { useTheme } from "next-themes";
export { Link } from "./mdx-components";
export { Bleed, Collapse, NotFoundPage, ServerSideErrorPage, Steps, Tabs, Tab, Cards, Card, FileTree, Navbar, SkipNavContent, SkipNavLink, ThemeSwitch } from "./components";
//# sourceMappingURL=index.js.map