var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import cn from "clsx";
import { Code, Pre, Table, Td, Th, Tr } from "nextra/components";
import { Children, cloneElement, useEffect, useRef, useState } from "react";
import { Anchor, Collapse } from "./components";
import { DetailsProvider, useDetails, useSetActiveAnchor } from "./contexts";
import { useIntersectionObserver, useSlugs } from "./contexts/active-anchor";
// Anchor links
function HeadingLink(_a) {
    var Tag = _a.tag, context = _a.context, children = _a.children, id = _a.id, props = __rest(_a, ["tag", "context", "children", "id"]);
    var setActiveAnchor = useSetActiveAnchor();
    var slugs = useSlugs();
    var observer = useIntersectionObserver();
    var obRef = useRef(null);
    useEffect(function () {
        if (!id)
            return;
        var heading = obRef.current;
        if (!heading)
            return;
        slugs.set(heading, [id, (context.index += 1)]);
        observer === null || observer === void 0 ? void 0 : observer.observe(heading);
        return function () {
            observer === null || observer === void 0 ? void 0 : observer.disconnect();
            slugs.delete(heading);
            setActiveAnchor(function (f) {
                var ret = __assign({}, f);
                delete ret[id];
                return ret;
            });
        };
    }, [id, context, slugs, observer, setActiveAnchor]);
    return (_jsxs(Tag, __assign({ className: cn("nx-font-semibold nx-tracking-tight nx-text-slate-900 dark:nx-text-slate-100", {
            h2: "nx-mt-10 nx-border-b nx-pb-1 nx-text-3xl nx-border-neutral-200/70 contrast-more:nx-border-neutral-400 dark:nx-border-primary-100/10 contrast-more:dark:nx-border-neutral-400",
            h3: "nx-mt-8 nx-text-2xl",
            h4: "nx-mt-8 nx-text-xl",
            h5: "nx-mt-8 nx-text-lg",
            h6: "nx-mt-8 nx-text-base"
        }[Tag]) }, props, { children: [children, _jsx("span", { className: "nx-absolute -nx-mt-20", id: id, ref: obRef }), _jsx("a", { href: "#".concat(id), className: "subheading-anchor", "aria-label": "Permalink for this section" })] })));
}
var findSummary = function (children) {
    var summary = null;
    var restChildren = [];
    Children.forEach(children, function (child, index) {
        var _a;
        if (child && child.type === Summary) {
            summary || (summary = child);
            return;
        }
        var c = child;
        if (!summary &&
            child &&
            typeof child === "object" &&
            child.type !== Details &&
            "props" in child &&
            child.props) {
            var result = findSummary(child.props.children);
            summary = result[0];
            c = cloneElement(child, __assign(__assign({}, child.props), { children: ((_a = result[1]) === null || _a === void 0 ? void 0 : _a.length) ? result[1] : undefined, key: index }));
        }
        restChildren.push(c);
    });
    return [summary, restChildren];
};
var Details = function (_a) {
    var children = _a.children, open = _a.open, props = __rest(_a, ["children", "open"]);
    var _b = __read(useState(!!open), 2), openState = _b[0], setOpen = _b[1];
    var _c = __read(findSummary(children), 2), summary = _c[0], restChildren = _c[1];
    // To animate the close animation we have to delay the DOM node state here.
    var _d = __read(useState(openState), 2), delayedOpenState = _d[0], setDelayedOpenState = _d[1];
    useEffect(function () {
        if (openState) {
            setDelayedOpenState(true);
        }
        else {
            var timeout_1 = setTimeout(function () { return setDelayedOpenState(openState); }, 500);
            return function () { return clearTimeout(timeout_1); };
        }
    }, [openState]);
    return (_jsxs("details", __assign({ className: "nx-my-4 nx-rounded nx-border nx-border-gray-200 nx-bg-white nx-p-2 nx-shadow-sm first:nx-mt-0 dark:nx-border-neutral-800 dark:nx-bg-neutral-900" }, props, { open: delayedOpenState }, (openState && { "data-expanded": true }), { children: [_jsx(DetailsProvider, { value: setOpen, children: summary }), _jsx(Collapse, { isOpen: openState, children: restChildren })] })));
};
var Summary = function (props) {
    var setOpen = useDetails();
    return (_jsx("summary", __assign({ className: cn("nx-flex nx-items-center nx-cursor-pointer nx-list-none nx-p-1 nx-transition-colors hover:nx-bg-gray-100 dark:hover:nx-bg-neutral-800", "before:nx-mr-1 before:nx-inline-block before:nx-transition-transform before:nx-content-[''] dark:before:nx-invert", "rtl:before:nx-rotate-180 [[data-expanded]>&]:before:nx-rotate-90") }, props, { onClick: function (e) {
            e.preventDefault();
            setOpen(function (v) { return !v; });
        } })));
};
var EXTERNAL_HREF_REGEX = /https?:\/\//;
export var Link = function (_a) {
    var _b = _a.href, href = _b === void 0 ? "" : _b, className = _a.className, props = __rest(_a, ["href", "className"]);
    return (_jsx(Anchor, __assign({ href: href, newWindow: EXTERNAL_HREF_REGEX.test(href), className: cn("nx-text-primary-600 nx-underline nx-decoration-from-font [text-underline-position:from-font]", className) }, props)));
};
var A = function (_a) {
    var _b = _a.href, href = _b === void 0 ? "" : _b, props = __rest(_a, ["href"]);
    return (_jsx(Anchor, __assign({ href: href, newWindow: EXTERNAL_HREF_REGEX.test(href) }, props)));
};
export var getComponents = function (_a) {
    var isRawLayout = _a.isRawLayout, components = _a.components;
    if (isRawLayout) {
        return { a: A };
    }
    var context = { index: 0 };
    return __assign({ h1: function (props) { return (_jsx("h1", __assign({ className: "nx-mt-2 nx-text-4xl nx-font-bold nx-tracking-tight nx-text-slate-900 dark:nx-text-slate-100" }, props))); }, h2: function (props) { return _jsx(HeadingLink, __assign({ tag: "h2", context: context }, props)); }, h3: function (props) { return _jsx(HeadingLink, __assign({ tag: "h3", context: context }, props)); }, h4: function (props) { return _jsx(HeadingLink, __assign({ tag: "h4", context: context }, props)); }, h5: function (props) { return _jsx(HeadingLink, __assign({ tag: "h5", context: context }, props)); }, h6: function (props) { return _jsx(HeadingLink, __assign({ tag: "h6", context: context }, props)); }, ul: function (props) { return (_jsx("ul", __assign({ className: "nx-mt-6 nx-list-disc first:nx-mt-0 ltr:nx-ml-6 rtl:nx-mr-6" }, props))); }, ol: function (props) { return (_jsx("ol", __assign({ className: "nx-mt-6 nx-list-decimal first:nx-mt-0 ltr:nx-ml-6 rtl:nx-mr-6" }, props))); }, li: function (props) { return _jsx("li", __assign({ className: "nx-my-2" }, props)); }, blockquote: function (props) { return (_jsx("blockquote", __assign({ className: cn("nx-mt-6 nx-border-gray-300 nx-italic nx-text-gray-700 dark:nx-border-gray-700 dark:nx-text-gray-400", "first:nx-mt-0 ltr:nx-border-l-2 ltr:nx-pl-6 rtl:nx-border-r-2 rtl:nx-pr-6") }, props))); }, hr: function (props) { return _jsx("hr", __assign({ className: "nx-my-8 dark:nx-border-gray-900" }, props)); }, a: Link, table: function (props) { return _jsx(Table, __assign({ className: "nextra-scrollbar nx-mt-6 nx-p-0 first:nx-mt-0" }, props)); }, p: function (props) { return _jsx("p", __assign({ className: "nx-mt-6 nx-leading-7 first:nx-mt-0" }, props)); }, tr: Tr, th: Th, td: Td, details: Details, summary: Summary, pre: Pre, code: Code }, components);
};
//# sourceMappingURL=mdx-components.js.map