import { createPopper } from "@popperjs/core";
import { useCallback, useMemo, useRef } from "react";
/**
 * https://github.com/tailwindlabs/headlessui/issues/59
 * Example implementation to use Popper: https://popper.js.org
 */
export function usePopper(options) {
    var reference = useRef(null);
    var popper = useRef(null);
    var cleanupCallback = useRef();
    var instantiatePopper = useCallback(function () {
        var _a;
        if (!reference.current || !popper.current)
            return;
        (_a = cleanupCallback.current) === null || _a === void 0 ? void 0 : _a.call(cleanupCallback);
        cleanupCallback.current = createPopper(reference.current, popper.current, options).destroy;
    }, [reference, popper, cleanupCallback, options]);
    return useMemo(function () { return [
        function (referenceDomNode) {
            reference.current = referenceDomNode;
            instantiatePopper();
        },
        function (popperDomNode) {
            popper.current = popperDomNode;
            instantiatePopper();
        }
    ]; }, [reference, popper, instantiatePopper]);
}
//# sourceMappingURL=use-popper.js.map